; Source code assembled with JWasm v2.06e built on Jul 22 2011
; Version 1.1

include ExitPE.inc

.data

ShutdownErr         db 'ExitPE cannot continue - unexpected error',13,10,0
welcome             db 'ExitPE - Command line tool to shutdown \ reboot Windows PE',13,10
                    db 'Version 1.1 by Vortex',13,10,13,10
                    db 'Usage :',13,10,13,10
                    db '       ExitPE -s : shutdown PE',13,10
                    db '       ExitPE -r : reboot',13,10,0


.data?

buffer              db 512 dup(?)
OldState            dd ?

.code

start:

    invoke  ParseCmdLine,OFFSET buffer
    cmp     eax,2
    jne     finish

    mov     edx,OFFSET buffer
    mov     ecx,DWORD PTR [edx+4]
    mov     eax,DWORD PTR [ecx]

    and     eax,0000FFFFh
    cmp     eax,'s-'
    je      @f

    cmp     eax,'r-'
    jne     finish
@@:

    shr     eax,8       ; remove the leading - sign from -s or -r
    sub     eax,71h     ; eax = ShutdownReboot   = 1
                        ; eax = ShutdownPowerOff = 2
    push    eax

    invoke  RtlAdjustPrivilege,SeShutdownPrivilege,TRUE,FALSE,\
            ADDR OldState

    pop     eax

    invoke  NtShutdownSystem,eax

    invoke  StdOut,ADDR ShutdownErr
    
    invoke  ExitProcess,0

finish:

    invoke  StdOut,ADDR welcome
    invoke  ExitProcess,0

END start

